//
//  BBSProxy.h
//  rss
//
//  Created by kunii on 09/10/21.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <libxml/tree.h>

@protocol BBSDelegate;							//	掲示板読み込み完了通知先プロトコル

@interface BBSProxy : NSObject {
	xmlParserCtxtPtr		_parserContext;		//	libxml用インスタンス
	NSMutableData*			htmlstring;			//	HTTP返信データ保存用
	NSMutableArray*			bbs;				//	bbs全項目
	NSMutableDictionary*	bbsItem;			//	bbs項目
	NSMutableString*		curtstring;			//	タグが持つ文字列用バッファ	
	id<BBSDelegate>			delegate;			//	掲示板読み込み完了通知先インスタンス
	NSString*				_name;				//	掲示板書き込み用名称
	NSString*				_comment;			//	掲示板書き込み用コメント
}
@property (nonatomic, readonly, retain) NSMutableArray*		bbs;
@property (nonatomic, readwrite, assign) id<BBSDelegate>	delegate;

//	掲示板読み込み
-(void)connect;
//	掲示板コメント書き込み
-(void)speak:(NSString*)string;
@end

//	掲示板読み込み完了通知先プロトコル
@protocol BBSDelegate<NSObject>
-(void)BBSChanged:(BBSProxy*)proxy;
@end

enum {
	keyword_Unknown = -1,
	keyword_Name = 1,
	keyword_Date,
	keyword_Comment
};

extern const NSString* keywords[];