//
//  RootViewController.m
//  rss
//
//  Created by kunii on 09/09/13.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import "RootViewController.h"

static const double TABLE_ROW_HEIGHT = 100;		//	テーブルの行の高さ。

@implementation RootViewController

- (void)viewDidLoad {
    [super viewDidLoad];

    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
	self.tableView.rowHeight = TABLE_ROW_HEIGHT;
	proxy = [[BBSProxy alloc] init];								//	掲示板通信インスタンス作成。
	proxy.delegate = self;											//	掲示板読み込み完了通知先インスタンスとして自分を設定。
	//	掲示板書き込み用テキストビューの用意。UISearchBarを使う。
	UISearchBar* bar = [[UISearchBar alloc] initWithFrame:CGRectMake(0,0,280,44)];
	[[[bar subviews] lastObject] setReturnKeyType:UIReturnKeyDone];	//	そのままだと検索というボタンになるので完了というボタンに変更。
	bar.showsCancelButton = YES;									//	キャンセルボタン表示
	bar.delegate = self;											//	UISearchBarの移譲先に自分を設定。
	self.navigationItem.titleView = bar;							//	ナビゲーションバーにUISearchBarを設定。
	[bar release];
	//	掲示板所得
	[proxy connect];
}

/*
	UISearchBarでのテキスト入力が完了した。
*/
-(void)searchBarSearchButtonClicked:(UISearchBar*)searchBar
{
	[searchBar resignFirstResponder];
	[proxy speak:searchBar.text];	
}

/*
	UISearchBarでのテキスト入力のキャンセルを希望された。
*/
- (void)searchBarCancelButtonClicked:(UISearchBar *)searchBar
{
	[searchBar resignFirstResponder];
}

/*
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
}
*/
/*
- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
}
*/
/*
- (void)viewWillDisappear:(BOOL)animated {
	[super viewWillDisappear:animated];
}
*/
/*
- (void)viewDidDisappear:(BOOL)animated {
	[super viewDidDisappear:animated];
}
*/

/*
 // Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	// Return YES for supported orientations.
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
 */

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release anything that can be recreated in viewDidLoad or on demand.
	// e.g. self.myOutlet = nil;
}


#pragma mark Table view methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return [proxy.bbs count];
}

// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath 
{
    static NSString *CellIdentifier = @"Cell";    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
		UILabel* name = [[UILabel alloc] initWithFrame:CGRectMake(0,0,100,20)];
		name.tag = keyword_Name;
		[cell addSubview:name];
		UILabel* date = [[UILabel alloc] initWithFrame:CGRectMake(100,0,200,20)];
		date.tag = keyword_Date;
		[cell addSubview:date];
		UILabel* comment = [[UILabel alloc] initWithFrame:CGRectMake(0,20,300,TABLE_ROW_HEIGHT - 20)];
		comment.tag = keyword_Comment;
		[cell addSubview:comment];
    }
	//	各ラベルへの掲示板の内容設定。
	NSMutableDictionary* item = [proxy.bbs objectAtIndex:indexPath.row];
	for (int tag = keyword_Name; tag <= keyword_Comment; tag++) {
		UILabel* label = (UILabel*)[cell viewWithTag:tag];
		label.text = [item objectForKey:keywords[tag]];
	}
    return cell;
}



/*
// Override to support row selection in the table view.
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {

    // Navigation logic may go here -- for example, create and push another view controller.
	// AnotherViewController *anotherViewController = [[AnotherViewController alloc] initWithNibName:@"AnotherView" bundle:nil];
	// [self.navigationController pushViewController:anotherViewController animated:YES];
	// [anotherViewController release];
}
*/


/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/


/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source.
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view.
    }   
}
*/


/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
}
*/


/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

/*
	掲示板読み込み完了。
*/
- (void)BBSChanged:(BBSProxy*)proxy 
{
	[self.tableView reloadData];
}

- (void)dealloc {
	[proxy dealloc];
    [super dealloc];
}


@end

